VERSION 5.00
Begin VB.Form frmPalette 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Color"
   ClientHeight    =   5070
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5985
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   338
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   399
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton Command2 
      Caption         =   "Exit"
      Height          =   465
      Left            =   2160
      MouseIcon       =   "frmPalette.frx":0000
      MousePointer    =   99  'Custom
      TabIndex        =   2
      Top             =   4440
      Width           =   1365
   End
   Begin VB.TextBox Text1 
      Enabled         =   0   'False
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2265
      Left            =   210
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      TabIndex        =   1
      Text            =   "frmPalette.frx":0152
      Top             =   1920
      Width           =   5565
   End
   Begin VB.PictureBox picPallet 
      AutoRedraw      =   -1  'True
      Height          =   1395
      Left            =   210
      ScaleHeight     =   1335
      ScaleWidth      =   1695
      TabIndex        =   0
      Top             =   240
      Width           =   1755
   End
End
Attribute VB_Name = "frmPalette"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function FrameRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Sub OleTranslateColor Lib "oleaut32.dll" (ByVal oleClearColor As Long, ByVal hpal As Long, ByRef lpcolorref As Long)

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private Type ColorInfo
    oleClearColor As OLE_COLOR
    Rectangle As RECT
End Type

Private NoOfColors(60) As ColorInfo
Private Const ColorValues = "&HFFFFFF&HC0C0FF&HC0E0FF&HC0FFFF&HC0FFC0&HFFFFC0&HFFC0C0&HFFC0FF&HE0E0E0&H8080FF&H80C0FF&H80FFFF&H80FF80&HFFFF80&HFF8080&HFF80FF&HC0C0C0&H0000FF&H0080FF&H00FFFF&H00FF00&HFFFF00&HFF0000&HFF00FF&H808080&H0000C0&H0040C0&H00C0C0&H00C000&HC0C000&HC00000&HC000C0&H404040&H000080&H004080&H008080&H008000&H808000&H800000&H800080" & "&H000000&H000040&H404080&H004040&H004000&H404000&H400000&H400040"
Private PalletLeft As Long
Private PalletTop As Long
 

Private Sub Command2_Click()
Unload Me
End Sub

Private Sub Form_Load()
    On Error Resume Next
    
    Dim iCount As Integer
    Dim LeftPosition As Long
    Dim TopPosition  As Long
    
    PalletLeft = 4: PalletTop = 0
    
    For iCount = 2 To 49
        LeftPosition = (((iCount - 2) Mod 8) + PalletLeft) + (((iCount - 2) Mod 8) * 12)
        TopPosition = (Int((iCount - 2) / 8) + (PalletTop + 4)) + (Int((iCount - 2) / 8) * 12)
        Call SetRect(NoOfColors(iCount).Rectangle, LeftPosition, TopPosition, LeftPosition + 16, TopPosition + 16)
    Next
    
    PalletTop = (PalletTop + 4) + (6 * 16) + 5
    
    For iCount = 1 To 60
        Dim oleClearColor As Long
        Dim CurrentBrush As Long
        Dim Rectangle As RECT
        
        NoOfColors(iCount).oleClearColor = CLng(Mid$(ColorValues, (iCount - 2) * 8 + 1, 8))
    
        Call SetRect(Rectangle, NoOfColors(iCount).Rectangle.Left + 2, NoOfColors(iCount).Rectangle.Top + 2, NoOfColors(iCount).Rectangle.Right - 2, NoOfColors(iCount).Rectangle.Bottom - 2)
        Call OleTranslateColor(NoOfColors(iCount).oleClearColor, ByVal 0&, oleClearColor)
        CurrentBrush = CreateSolidBrush(oleClearColor)
        Call FillRect(picPallet.hdc, Rectangle, CurrentBrush)
        
        Call OleTranslateColor(vbGrayText, ByVal 0&, oleClearColor)
        CurrentBrush = CreateSolidBrush(oleClearColor)
        Call FrameRect(picPallet.hdc, Rectangle, CurrentBrush)
    Next
End Sub

